<?php
/*
    This file is a part of DAlbum.  Copyright (c) 2003 Alexei Shamov

    Feel free to modify this file. Function examples were deleted from this
    file but you can always found them on DAlbum web-site: http://www.dalbum.org

*/

// Load configuration
$g_nCommentsMode=0;
$g_bShowImageTitles=1;
$g_bShowSlideOnly=1;
$g_bShowExifLine=1;
$g_sCommentsAdminEMail="";
$g_sCommentsFromEMail="";
$configFile=$g_sPrivateDir . "/.config.dat";

if (file_exists($configFile))
{
    $set=array();
    $handle = @fopen($configFile, "rb");
    if ($handle)
    {
        @clearstatcache();
        $size=filesize ($configFile);
        $set=unserialize(fread ($handle, $size));
        fclose ($handle);
    }

    if (!empty($set) && is_array($set))
        while (list($k,$v)=each($set))
        {
            if (substr($k,0,2)=="g_")
                $GLOBALS[$k]=$v;
        }
}

// Insert histogram into exif details, if allowed
function customExifDetails( $sFilename,
                            &$exif,
                            &$data )
{
    $sExifDetails.="<table>";
    $sExifDetails.="<tr><th colspan=2>{$lang['showExifDialogTitle']}</th></tr>";
   foreach ($data as $d)
    {
        list($name,$value)=split('\|',$d);
        $sExifDetails.=("<tr><td class='imgParamName'>$name</td><td class='imgParamValue'>$value</td></tr>");
    }
    global $g_bShowHist,$image;
    if ($g_bShowHist)
    {
        $hist=translateRef("hist.php?file=".quoteurl($image->m_sFullFilename));
        $sExifDetails.="<tr><td colspan=\"2\" style=\"text-align=center;\"><img style=\"border:0;padding:0;margin:0;\" src=\"$hist\" /></td></tr>";
    }


    $sExifDetails.= "</table>";
    return $sExifDetails;

}

function customTitle(&$object, $titleDefault)
{
    $ret=$titleDefault;

    global $g_nCommentsMode,$sUserName,$g_bShowImageTitles;
    if (!$g_bShowImageTitles)
        return "";
    if ($g_nCommentsMode)
    {
        $bShowComments=($g_nCommentsMode<3 || !empty($sUserName));
        if ($object->IsImage() && $bShowComments)
        {
            $imagefname=absfname($object->m_sFullFilename);
            $textfname=dirname_ex($imagefname) . "/" . getfname($imagefname) . ".cmt";

            $cnt=0;
            if (file_exists($textfname))
            {
                $f=@safe_read_file($textfname);
                foreach ($f as $line)
                    if (strlen(trim($line)))
                        $cnt++;
            }
            if ($cnt)
                $ret="<span class='imageTitle'>" . $object->GetTitle() . "&nbsp;<sub>($cnt)</sub></span>";
        }
    }
    return $ret;
}


/*** Slideshow begins ***/

// Returns custom button code. You can completely change style of all DAlbum buttons
// here, hide buttons you don't need, add images to buttons, use <BUTTON> instead of <A> tag etc.
//
//  $id = button ID. Possible values: 'login','logout','next','prev','usrmgr','index',
//                  'fullscreen' etc.
//  $href=location for this button. Empty string for disabled button
//  $text=button text
//  $title=help for button
//  $nSpacer= 0=first button in the row, 1=usual button, 2=first button in button group
//  $target=target
//
// Return value: button code. Check getButton code in functions.php for details
//

class createZip
{
     var $centralDirectory = array(); // central directory
     var $endOfCentralDirectory = "\x50\x4b\x05\x06\x00\x00\x00\x00"; //end of Central directory record
     var $oldOffset = 0;

     var $files     = array();
     var $dirnames      = array();


    /**
     * Function to create the directory where the file(s) will be unzipped
     *
     * @param $directoryName string
     *
     */
     function addDirectory($directoryName)
    {
        $this->files[]="";
        $this->dirnames[]=$directoryName;
    }

     function addFile($file, $directoryName)
    {
        $this->files[]=$file;
        $this->dirnames[]=$directoryName;
    }

     function estimateSize()
    {
        $this -> oldOffset=0;
        $this -> centralDirectory = array();

        $size=0;
        for ($i=0;$i<count($this->files);++$i)
        {
            $size=$size+$this->writeFile($this->files[$i],$this->dirnames[$i],false);
        }
        $controlDirectory = implode("", $this -> centralDirectory);
        $size+=strlen($controlDirectory);
        $size+=strlen($this -> endOfCentralDirectory);
        $size+=4+8+2;
        return $size;
    }

     function writeZIP()
    {
        $this -> oldOffset=0;
        $this -> centralDirectory = array();
        $size=0;
        for ($i=0;$i<count($this->files);++$i)
        {
            $size+=$this->writeFile($this->files[$i],$this->dirnames[$i],true);
        }


        $controlDirectory = implode("", $this -> centralDirectory);

        print   $controlDirectory.
                $this -> endOfCentralDirectory.
                pack("v", sizeof($this -> centralDirectory)).
                pack("v", sizeof($this -> centralDirectory)).
                pack("V", strlen($controlDirectory)).
                pack("V", $this -> oldOffset).
                "\x00\x00";
    }


     function writeFile($filename,$directoryName,$write)
    {
        $directoryName = str_replace("\\", "/", $directoryName);

        $crc=0;
        $size=filesize($filename);
        $data="";
        if ($write && !empty($filename))
        {
            $data=file_get_contents($filename);
            $crc=crc32($data);
        }
        $writtenBytes=0;

        $header = "\x50\x4b\x03\x04";
        $header .= "\x14\x00";          // ver needed to extract
        $header .= "\x00\x00";              // gen purpose bit flag
        $header .= "\x00\x00";          // compression method (0 = store)
        $header .= "\x00\x00\x00\x00";  // last mod time and date

        $header .= pack("V",$crc);
        $header .= pack("V",$size);
        $header .= pack("V",$size);
        $header .= pack("v", strlen($directoryName) );
        $header .= pack("v", 0 );
        $header .= $directoryName;

        // Write file header
        if ($write)
            print $header;
        $writtenBytes+=strlen($header);

        // Write file
        if ($write)
            print $data;
        $writtenBytes+=$size;

        // Write suffix
        $suffix = pack("V",$crc);
        $suffix .= pack("V",$size);
        $suffix .= pack("V",$size);

        if ($write)
            print $suffix;
        $writtenBytes+=strlen($suffix);

        // Calculate offset
        $newOffset = $this -> oldOffset + $writtenBytes;

        $addCentralRecord = "\x50\x4b\x01\x02";
        $addCentralRecord .="\x00\x00";
        $addCentralRecord .="\x14\x00";
        $addCentralRecord .="\x00\x00";
        $addCentralRecord .="\x00\x00";
        $addCentralRecord .="\x00\x00\x00\x00";
        $addCentralRecord .= pack("V",$crc);
        $addCentralRecord .= pack("V",$size);
        $addCentralRecord .= pack("V",$size);
        $addCentralRecord .= pack("v", strlen($directoryName) );
        $addCentralRecord .= pack("v", 0 );
        $addCentralRecord .= pack("v", 0 );
        $addCentralRecord .= pack("v", 0 );
        $addCentralRecord .= pack("v", 0 );

        // Mark file as archive and dir as directory (MS DOS file attrs)
        if (!empty($filename))
            $addCentralRecord .= pack("V", 32 );
        else
            $addCentralRecord .= pack("V", 16 );

        //
        $addCentralRecord .= pack("V", $this -> oldOffset );
        $this -> oldOffset = $newOffset;
        $addCentralRecord .= $directoryName;
        $this -> centralDirectory[] = $addCentralRecord;
        return $writtenBytes;
    }
}


function customGetButton($id, $href, $text, $title, $nSpacer, $target)
{
    global $lang;
    $ret="";

    // Display slideshow combo before 'fullscreen' button
    // and only on showimg.php page
    if (($id=='fullscreen'||$id=='closewindow') && defined('DALBUM_SHOWIMG_PAGE'))
    {
        // Add a little space before the combo
        $ret = '<span id="space_slideshow" class="buttonspace">&nbsp;&nbsp;&nbsp;</span>';

        // Localize Slideshow: string here
        $ret.= '<span class="slideshow">';
        $ret.= '<form onsubmit="">';
        $ret.= "<select onchange='onSlideshowChange(this);'>";

        // Number of seconds/slide to be displayed in the combo-box.
        $seconds=array(0,5,10,30,60);

        $def=0;
        if (isset($_GET['slideshow']))
            $def=$_GET['slideshow'];

        foreach ($seconds as $s)
        {
            $ret.="<option value=\"$s\"";
            if ($s==$def)
                $ret.=" selected";
            $ret.=">";

            if ($s==0)
                $ret.=$lang['cSlideshowSlideshow'];
            else
                $ret.=strtr($lang['cSlideshowSeconds'],array("#sec#"=>$s));
            $ret.="</option>";
        }
        $ret.='</select></form>';
        $ret.='</span>';

    }
    // if we are in slideshow mode already - do not display "Fullscreen"
    if ($id=='fullscreen' &&
        defined('DALBUM_SHOWIMG_PAGE') &&
        isset($_GET['slideshow']))
        return $ret;

    global $album;
    $ret.=getButton($id,$href,$text,$title,$nSpacer,$target,false);
    global $sUserName;
    if ($id=='logout' && isAdminMode($sUserName))
    {
        $ret.=getButton("configure",translateRef("configpg.php"),"Configure","Configure settings",2,"",false);
    }

    if (($id=='#albCommands#begin#') && defined('DALBUM_INDEX_PAGE'))
    {
        if ($album->GetCustomField("AllowZIPDownload")>0)
        {
            $size=$album->GetZIPSize();
            if ($size)
            {
                $url=translateRef('zip.php?folder=' . quoteurl($album->m_sFolder));;
                $ret.=getButton("zip",$url, strtr($lang['cZipBtn'],array("#size#"=>size_as_str($size))),
                                            strtr($lang['cZipBtnTitle'],array("#size#"=>size_as_str($size))),
                                            $nSpacer,"",false);
                $ret.="&nbsp;&nbsp;";
            }
        }
    }



    return $ret;
}

/*** Slideshow ends ***/

/*** customtypes sample begins ***/
require_once(DALBUM_ROOT . "/config/customtypes.php");

class CSortImage extends CCustomTypeImage
{
    function &GetCustomFieldNames()
    {
        $f=parent::GetCustomFieldNames();
        $f[]="SortOrder";
        return $f;
    }
}

function &customCreateImage()
{
    $tmp=new CSortImage();
    return $tmp;
}
/*** customtypes sample ends ***/

/*** Display modified albums begins ***/

// Localize text strings below (these localizations will be added
// to DAlbum installation later)
if (!isset($lang['cModifiedNew']))
{
    $lang['cModifiedNew']='new!';
    $lang['cModifiedUpdated']='updated!';
}

class CExAlbumModified extends CAlbum
{
    function Create($sPath, $parentUsers,$bCleanup, $bDeleteImages=false)
    {
        // New albums get modification time set to today's date
        if (!file_exists(absfname($sPath."/.albumdef.ini")))
        {
            $this->m_arrCustomFields["Modified_YYMMDD"]=
            $this->m_arrCustomFields["Created_YYMMDD"]=date("ymd");
        }

        // Call default implementation
        return parent::Create($sPath,$parentUsers,$bCleanup,$bDeleteImages);
    }


    // Get list of custom field names
    function &GetCustomFieldNames()
    {
        $f=parent::GetCustomFieldNames();
        $f[]="Created_YYMMDD";
        $f[]="Modified_YYMMDD";
        $f[]="SortOrder";
        $f[]="AllowZIPDownload";
        return $f;
    }

    // Modify tree node text
    function GetTreeNodeCode($myID,$nParentID,$sText,$sRef)
    {
        // Display (Modified) or (Updated) for those modified/updated 10 days ago or less.
        // (change 10 to any number of days you wish)
        $dateRecent=date("ymd",time()-86400*10);

        $cur_ct=$this->GetCustomField("Created_YYMMDD");
        $cur_mt=$this->GetCustomField("Modified_YYMMDD");

        global $lang;
        $sAdd="";

        $dr=DALBUM_BROWSERROOT;
        // Modify tree item text
        if ($cur_ct>$dateRecent)
        {
            // display custimg/new.gif next to new albums
            $sAdd="&nbsp;<sup><img src=\'{$dr}custimg/new.gif\' alt=\'\' title=\'".
                                $lang['cModifiedNew']."\'></sup>";

            // Uncomment the next line to display text instead of images
            // $sAdd="&nbsp;<sup><b>".$lang['cModifiedNew']."</b></sup>";
        }
        elseif ($cur_mt>$dateRecent)
        {
            // display custimg/updated.gif next to updated albums
            $sAdd="&nbsp;<sup><img src=\'{$dr}custimg/updated.gif\' alt=\'\' title=\'".
                                $lang['cModifiedUpdated']."\'></sup>";

            // Uncomment the next line to display text instead of images
            // $sAdd="&nbsp;<sup><b>".$lang['cModifiedUpdated']."</b></sup>";
        }

        if (!empty($sAdd) && $this->m_sFolder!='/')
            $sText.=$sAdd;

        // Call default implementation to display updated string.
        return parent::GetTreeNodeCode($myID,$nParentID,$sText,$sRef);
    }


    // This function is always called during reindex AFTER subfolders are loaded
    function ParseDetails(&$ini_array,$bAllDetails)
    {
        parent::ParseDetails($ini_array,$bAllDetails);

        // Get modified time for this folder
        $cur_mt=$this->GetCustomField("Modified_YYMMDD");
        if (strlen($cur_mt)!=6)
            $cur_mt="000000";
        $cur_ct=$this->GetCustomField("Created_YYMMDD");
        if (strlen($cur_ct)!=6)
            $cur_ct="000000";

        // Go through all subfolders and set this folder modification time
        // to not be before any subfolder modification time
        for ($i=0;$i<count($this->m_arrContents);++$i)
        {
            $obj=&$this->m_arrContents[$i];
            if (!$obj->IsImage())
            {
                $mt=$obj->GetCustomField("Modified_YYMMDD");
                if (!empty($mt) && $mt>$cur_mt)
                    $cur_mt=$mt;
            }
        }
        if ($this->GetCustomField("Modified_YYMMDD")!=$cur_mt)
        {
            $this->m_arrCustomFields["Modified_YYMMDD"]=$cur_mt;
            $this->m_arrCustomFields["Created_YYMMDD"]=$cur_ct;
            create_defaultIni($this,true);
        }
    }

    // This is used to customize sorting order
    function cmpAlb2($a, $b)
    {
        $ai=$a->IsImage();
        $bi=$b->IsImage();

        // If both are images or both are albums look at "SortOrder"
        if ( ($ai && $bi) || (!$ai && !$bi))
        {
            $v1=(int)trim(strval($a->GetCustomField("SortOrder")));
            $v2=(int)trim(strval($b->GetCustomField("SortOrder")));
            if ($v1!=$v2)
                return $v1-$v2;
        }

        // No sort order preference. Try names

        // If both are images - compare filenames
        if ($ai && $bi)
            return strcasecmp($a->m_sBaseFilename, $b->m_sBaseFilename);

        // Albums always go before images
        if ($ai)
            return 1;
        if ($bi)
            return -1;

        // Both are albums - compare folders
        return strcasecmp(basename(substr($a->m_sFolder,0,-1)), basename(substr($b->m_sFolder,0,-1)));
    }

    function Sort()
    {
        if (!empty($this->m_arrContents))
            usort($this->m_arrContents,array(get_class($this),"cmpAlb2"));
    }

    // ZIP stuff
    function &CreateZIP()
    {
        $createZip = new createZip;
        $dir=basename(substr($this->m_sFolder,0,-1));

        $createZip -> addDirectory($dir);

        $any=false;
        for ($i=0;$i<count($this->m_arrContents);++$i)
        {
            $obj=&$this->m_arrContents[$i];
            if ($obj->IsImage())
            {
                $imagefname=absfname($obj->m_sFullFilename);
                $createZip->addFile($imagefname,$dir."/".basename($imagefname));
                $any=true;
            }
        }
        if (!$any)
            return null;
        return $createZip;
    }

    function GetZIPSize()
    {
        $createZip = &$this->CreateZIP();
        if ($createZip===null)
            return 0;
        return $createZip->estimateSize();

    }
    function WriteZIP()
    {
        $createZip = $this->CreateZIP();
        $name=basename(substr($this->m_sFolder,0,-1)).".zip";

        if (!empty($createZip))
        {
            header("Content-type: application/octet-stream");
            header('Content-Disposition: inline; filename="' . $name . '"');
            header("Content-length: " . $createZip->estimateSize());

            @set_time_limit(86400);   // set long timeout


            $createZip->writeZIP();
        }
    }

}

function &customCreateAlbum()
{
    $tmp=new CExAlbumModified();
    return $tmp;
}

/*** Display modified albums ends ***/

?>