<?php /*----------------------------------------------------------------

  This is template of the DAlbum showimg page. Feel free to modify it
  to suit your website.


  The following variables are set:

    $albRoot    : root album (class CAlbum)
    $album      : current album (class CAlbum)
    $image      : current image (class CImage)
    $sUserName  : current user name
    $bAdminMode : true if current user is admin
    $next       : encoded url of the next image page (or empty for last page)
    $prev       : encoded url of the previous image page (or empty for first page)
    $first      : encoded url of the first image in album
    $last       : encoded url of the last image in album

  It is not recommented rely on other variables as they may change in
  the future versions.

  --------------------------------------------------------------------*/
    if (!defined('DALBUM_ROOT'))     die("Security problem");


    ////////////// Image Comments customization 1 of 2 begins ///////////////
    include(DALBUM_ROOT . "/config/comments.php");

    $bSlideShow=isset($_GET['slideshow']);
    $g_bShowSlideOnly=($g_bShowSlideOnly && $bSlideShow);

    if ($g_bShowSlideOnly)
    {
        $_template['ImageAlt']=$lang['cSlideshowStopTitle'];
    }

    if ($g_nCommentsMode)
    {
        if (DAlbum_Comments_Plugin_Send(    $g_nCommentsMode-1,
                                            $g_sCommentsAdminEMail,
                                            $g_sCommentsFromEmail ))
        {
            header("Location: " . base64_decode(encodeCurrentLocation()));
            return;
        }
    }

    ////////////// Image Comments customization 1 of 2 ends ///////////////
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php print $g_sCharset;?>">
<meta http-equiv="imagetoolbar" content="no">

<script src="<?php print DALBUM_BROWSERROOT . 'dalbum.js'; ?>" type="text/javascript"></script>
<link rel="stylesheet" href="<?php print $g_sStylesheet; ?>" type="text/css">
<link rel="stylesheet" href="<?php print $g_sCustomStylesheet; ?>" type="text/css" >

<title><?php template('Title'); ?></title>
<?php template('Head'); ?>
<script type='text/javascript'>
//<!--
<?php template('HeadJavascript'); ?>
//-->
</script>
</head>

<!-- Begin page -->
<body class="nomargins" onload="javascript: dalbum_onload();_slideshow();" id="showimgBody">
<table class="pagetable" cellspacing="0" cellpadding="0" id="showimgPagetable">

<!-- Row 1: header -->
<?php if (!$g_bShowSlideOnly) { ?>

<tr><td style="vertical-align:top;">
<div class="imgHeader">
<div class="navigationBar">
<?php template('NavigationBar'); ?>
</div>

<div class='title'>
<?php template('ImageTitle'); ?>
</div>
<?php if (!$bSlideShow) template('ImageComment'); ?>
</div>
</td>
</tr>

<?php  } ?>

<!-- Row 2: image -->
<tr>
<td class="showImgPane" id="imageRow" >
<center>
<table border="0" cellpadding="2" cellspacing="2" >
<tr id="imageWrap">
<?php if (!$g_bShowSlideOnly && isset($_template['ExifDetails'])) { ?>
        <td style='vertical-align: top'>
        <div class='imgDetails'>
<?php   template('ExifDetails');?>
        </div>
        </td>
<?php } /* ExifDetails */ ?>

<td id="showimgImageCell">

<?php if (!cCustom_DisplayCustomType($image)) { /*** customtypes sample ***/ ?>

    <a href="<?php template('ImageHref');?>">
    <img id="Image"
         src="<?php template('ImageSrc');?>"
         title="<?php template('ImageAlt');?>"
         <?php template('ImageWidthHeight'); ?>
         alt="">
    </a>

<?php
        global $g_bShowExifLine;
        if (!$g_bShowSlideOnly && $g_bShowExifLine)
        {
            print '<div style="font-size:8pt;white-space:nowrap;text-align:center;">';
            include(DALBUM_ROOT . "/config/exifline.php");
            print '</div>';
        }

}  /*** customtypes sample ***/ ?>

</td>
</tr>
</table>
</center>
</td></tr>

<?php
////////////// Image Comments customization 2 of 2 begins ///////////////
if ($g_nCommentsMode && !$bSlideShow && !$g_bShowSlideOnly)
{
    if ($g_sBrowserFitMethod=="shrink" || $g_sBrowserFitMethod="height_fit")
        $_template["BrowserFitMethod"]="";

    DAlbum_Comments_Plugin_Display($g_nCommentsMode-1);
}
////////////// Image Comments customization 2 of 2 ends ///////////////

if (!$g_bShowSlideOnly)
{
?>


<!-- Row 3: copyright -->
<tr><td style="vertical-align:bottom;" class="tdCopyright">

<div class="copyright" id="imageFooter">
    <?php template('PageFooter'); ?>
</div>

</td></tr>
<?php } ?>

</table>

<script type="text/javascript">
    <?php template('EndPageJavascript'); ?>
//<!--
    // This code eliminates vertical scrollbar which is otherwise
    // unnecesarlily displayed with panoramic images. It also handles
    // "Fit to window" resize in DOM-supporting browsers.
    dalbum_showimg_resize('showimgPagetable','Image','imageRow','imageWrap',
                            <?php template('ImageSizeX');?>,
                            <?php template('ImageSizeY');?>,
                            '<?php template("BrowserFitMethod");?>');

    <!-- Begin slideshow code -->
        function _slideshow()
        {
<?php       $nSlideShow=0;
            if (isset($_GET['slideshow']))
                    $nSlideShow=$_GET['slideshow'];
            if ($nSlideShow>0)
            {
                // Change 5 here to minimal allowed interval in seconds
                if ($nSlideShow<5)
                    $nSlideShow=5;
                $url=$next;
                if (empty($url))
                {
                    // !!! Uncomment the next line enable slide show looping
                    // $url=$first;
                }

                $delay=$nSlideShow*1000;
                if (!empty($url))
                    $url.="&slideshow=" . $nSlideShow;
                else
                    $url=strtr($last,array("&amp;"=>"&"));

                $url=strtr($url,array("&amp;"=>"&"));
                print "window.setTimeout(\"window.location.replace('$url');\",$delay);";
            }?>
        }

        function onSlideshowChange(combo)
        {
            var u=window.location.href;
            var n=u.indexOf('&slideshow');
            if (n!=-1)
                    u=u.substr(0,n);

            if (combo.selectedIndex>0)
                    u+="&slideshow=" + combo.options[combo.selectedIndex].value;

            window.location.replace(u);
            return true;
        }
        <!-- End slideshow code -->
//-->
</script>

</body>
</html>