<?php
    // Histogram parameters
    $windowX=256;   // histogram width and height
    $windowY=100;   //
    $brd=2;         // border around the histogram window
    $sizem=300;     // Accuracy (the more the slower)

    //
    if (!defined("DALBUM_ROOT"))
        define("DALBUM_ROOT",".");
    if (!defined("DALBUM_BROWSERROOT"))
        define("DALBUM_BROWSERROOT","");

    define("DALBUM_HISTOGRAM_PAGE","1");

    require_once(DALBUM_ROOT."/include/md5crypt.php");
    require_once(DALBUM_ROOT."/include/functions.php");
    require_once(file_exists(DALBUM_ROOT."/config/config.php")?DALBUM_ROOT."/config/config.php":DALBUM_ROOT."/include/config.php");
    require_once(DALBUM_ROOT."/include/conffix.php");
    require_once(DALBUM_ROOT."/include/album.php");

    // Include custom functions
    if (file_exists(DALBUM_ROOT."/config/custom.php"))
        include_once(DALBUM_ROOT."/config/custom.php");
    elseif (file_exists(DALBUM_ROOT."/include/custom.php"))
        include_once(DALBUM_ROOT."/include/custom.php");

    remove_bloody_magic_quotes();

    $sUserName=StartSessionAndGetUserName('private_no_expire');
    if (function_exists('everypageCallback'))
        everypageCallback($sUserName);

    global $g_sResizedPrefix;
    global $g_sThumbnailPrefix;
    $sFile=@$_GET['file'];

    $image=&createImage();
    $image->Init($sFile);

    if ($sFile=="" || !$image->IsImageFilename())
    {
        hdr("404 Not found");
        return;
    }

    $sFile=absfname($image->m_sFullFilename);
    if (!file_exists($sFile))
    {
        hdr("404 Not found");
        return;
    }


    $imginfo = @getimagesize($sFile);
    if (empty($imginfo))
        die();

    switch($imginfo[2])
    {
        case 1: $type = IMG_GIF; break;
        case 2: $type = IMG_JPG; break;
        case 3: $type = IMG_PNG; break;
        case 4: $type = IMG_WBMP; break;
        default: die();
    }


    // height/width
    $srcX = $imginfo[0];
    $srcY = $imginfo[1];

    $mem=(int)((3*$srcX*$srcY*4)/1000/1000+8);
    @ini_set("memory_limit", "{$mem}M");


    switch($type)
    {
        case IMG_GIF:
            if(function_exists('imagecreatefromgif'))
                $srcImage = imagecreatefromgif($sFile);
            break;
        case IMG_JPG:
            if(function_exists('imagecreatefromjpeg'))
                $srcImage = imagecreatefromjpeg($sFile);
            break;
        case IMG_PNG:
            if(function_exists('imagecreatefrompng'))
                $srcImage = imagecreatefrompng($sFile);
            break;
        case IMG_WBMP:
            if(function_exists('imagecreatefromwbmp'))
                $srcImage = imagecreatefromwbmp($sFile);
            break;
    }

    // If image is larger than
    $sizem=300;
    if ($srcX * $srcY >$sizem*$sizem)
    {
        // resizeImage to
        // resize
        $destImage=imageCreatetruecolor($sizem,$sizem);
        $bSuccess= imagecopyresized($destImage, $srcImage, 0, 0, 0, 0, $sizem, $sizem, $srcX, $srcY);
        $srcX=$srcY=$sizem;
        @imagedestroy($srcImage);
        $srcImage=$destImage;
    }

    $lev=array();
    $r=array();
    $g=array();
    $b=array();
    $n=0;

    for ($i=0;$i<256;++$i)
        $r[$i]=$g[$i]=$b[$i]=$lev[$i]=0;

    for ($x=0;$x<$srcX;$x++)
        for ($y=0;$y<$srcY;$y++)
        {
            $rgb=imagecolorat($srcImage,$x,$y);
            $r[(($rgb>>16)&0xff)]++;
            $g[(($rgb>> 8)&0xff)]++;
            $b[ ($rgb     &0xff)]++;
        }

    @imagedestroy($srcImage);

    // Calculate maximums
    $m=1;
    $m1=1;
    $avg=$srcX*$srcY*6/256;
    for ($i=0;$i<256;++$i)
    {
        $lev[$i]=($r[$i]+$g[$i]+$b[$i])/3;
        $m=min($avg,max($m,$lev[$i]));
        $m1=min($avg,max($m1,$r[$i],$g[$i],$b[$i]));
    }
    $m1=$m1*0.95;
    $m=$m*0.95;

    // Prepare image
    $destImage = imagecreate($windowX+$brd*2, $windowY+$brd*2);
    $white = imagecolorallocate($destImage, 0x54, 0x54, 0x54);
    $black = imagecolorallocate($destImage, 128, 128, 128);
    $red = imagecolorallocate($destImage, 255, 0, 0);
    $green = imagecolorallocate($destImage, 0, 255,0);
    $blue = imagecolorallocate($destImage, 0, 0, 255);
    $border = imagecolorallocate($destImage, 20, 20, 128);

    imagefill($destImage,0,0,$white);


    // Draw it
    for ($i=0;$i<256;++$i)
    {
        $lev[$i]=(int)min(($lev[$i]*$windowY/$m),$windowY);
        $r[$i]=(int)min(($r[$i]*$windowY/$m1),$windowY);
        $g[$i]=(int)min(($g[$i]*$windowY/$m1),$windowY);
        $b[$i]=(int)min(($b[$i]*$windowY/$m1),$windowY);

        $x=(int)($i/256*$windowX)+$brd;
        if ($i)
            $x1=(int)(($i-1)/256*$windowX)+$brd;

        imageline( $destImage,  $x, $windowY+$brd,
                                $x, $windowY-$lev[$i]+$brd, $black);

        if ($i==0)
        {
            imagesetpixel( $destImage, $x, $windowY-$r[$i]+$brd, $red);
            imagesetpixel( $destImage, $x, $windowY-$g[$i]+$brd, $green);
            imagesetpixel( $destImage, $x, $windowY-$b[$i]+$brd, $blue);
        }
        else
        {
            imageline( $destImage,  $x1, $windowY-$r[$i-1] +$brd,
                                    $x , $windowY-$r[$i]   +$brd, $red);
            imageline( $destImage,  $x1, $windowY-$g[$i-1] +$brd,
                                    $x , $windowY-$g[$i]   +$brd, $green);
            imageline( $destImage,  $x1, $windowY-$b[$i-1] +$brd,
                                    $x , $windowY-$b[$i]   +$brd, $blue);
        }
    }


    ob_start();
    imagejpeg($destImage, '', 75);
    $s = ob_get_contents();
    ob_end_clean();

    header('Content-type: image/png');
    header('Content-length: '.strlen($s));
    print $s;

    @imagedestroy($destImage);

?>